*
* dCONV.INC
*
* Implements MAL_TLG(STRING,START_FONT)
* with a debugging routine that pokes the string
* ERRORCODE into any position where undefined
* strings occur
*
* This function converts one Malitz-coded string to beta-code.
*
* START_FONT:		0	Latin
*			1	Greek
*
* The module uses table TLGTABLE<> for conversion
*
*
*
*
*
	GREEK = 1
	LATIN = 0
*
*
*
	TLGTABLE = TABLE(,,'ERRORCODE')
	TLGTABLE<000> =
* undocumented code
	TLGTABLE<001> = ''
*
* GREEK PORTION 02 - 13
*
	TLGTABLE<002> = "A\|"
	TLGTABLE<003> = "A)|"
	TLGTABLE<004> = "A(|"
	TLGTABLE<005> = "A(/|"
	TLGTABLE<006> = "A(\|"
	TLGTABLE<007> = "A)=|"
	TLGTABLE<008> = "A=(|"
	TLGTABLE<009> = "H/|"
	TLGTABLE<010> = "H\|"
	TLGTABLE<011> = "H)|"
	TLGTABLE<012> = "H(|"
	TLGTABLE<013> = "H(/|"
*
* LATIN PORTION 14-18
*
	TLGTABLE<014> = "[1denarius]1"
*
*
*
	TLGTABLE<015> = '#322'
	TLGTABLE<016> = "[1milliaria]1"
*
*
*
	TLGTABLE<017> = '[1centuria]1'
	TLGTABLE<018> = '#59'
*
* GREEK PORTION 19 - 38
*

	TLGTABLE<019> = 'Q'
	TLGTABLE<020> = "H(\|"
	TLGTABLE<021> = "R)"
	TLGTABLE<022> = "E(\"
	TLGTABLE<023> = "A(\"
	TLGTABLE<024> = "E)\"
	TLGTABLE<025> = "A/|"
	TLGTABLE<026> = "I)\"
	TLGTABLE<027> = "O)\"
	TLGTABLE<028> = "U)\"
	TLGTABLE<029> = "H)\"
	TLGTABLE<030> = ":"
	TLGTABLE<031> = ";"
	TLGTABLE<032> = " "
* undocumented code
	TLGTABLE<033> = '%4'
* undocumented code
	TLGTABLE<034> = '"'
	TLGTABLE<035> = "H=)|"
	TLGTABLE<036> = "W(\"
* WAS SOLL DAS ?
	TLGTABLE<037> = "%"
	TLGTABLE<038> = "W(\|"
*
*
*
*
* LATIN PORTION 39 - 91
*
* undocumented code
	TLGTABLE<039> = '"3 '
	TLGTABLE<040> = "[1"
	TLGTABLE<041> = "]1"
* undocumented code
	TLGTABLE<042> = "%2"
	TLGTABLE<043> = "%7"
* undocumented code
	TLGTABLE<044> = ","
*
	TLGTABLE<045> = "_"
*
	TLGTABLE<046> = "."
	TLGTABLE<047> = "%3"
	TLGTABLE<048> = "0"
	TLGTABLE<049> = "1"
	TLGTABLE<050> = "2"
	TLGTABLE<051> = "3"
	TLGTABLE<052> = "4"
	TLGTABLE<053> = "5"
	TLGTABLE<054> = "6"
	TLGTABLE<055> = "7"
	TLGTABLE<056> = "8"
	TLGTABLE<057> = "9"
	TLGTABLE<058> = "#73"
	TLGTABLE<059> = ";"
	TLGTABLE<060> = "[2"
	TLGTABLE<061> = "%6"
	TLGTABLE<062> = "]2"
	TLGTABLE<063> = "?"
* 64 fehlt offenbar
	TLGTABLE<065> = "A"
	TLGTABLE<066> = "B"
	TLGTABLE<067> = "C"
	TLGTABLE<068> = "D"
	TLGTABLE<069> = "E"
	TLGTABLE<070> = "F"
	TLGTABLE<071> = "G"
	TLGTABLE<072> = "H"
	TLGTABLE<073> = "I"
	TLGTABLE<074> = "J"
	TLGTABLE<075> = "K"
	TLGTABLE<076> = "L"
	TLGTABLE<077> = "M"
	TLGTABLE<078> = "N"
	TLGTABLE<079> = "O"
	TLGTABLE<080> = "P"
	TLGTABLE<081> = "Q"
	TLGTABLE<082> = "R"
	TLGTABLE<083> = "S"
	TLGTABLE<084> = "T"
	TLGTABLE<085> = "U"
	TLGTABLE<086> = "V"
	TLGTABLE<087> = "W"
	TLGTABLE<088> = "X"
	TLGTABLE<089> = "Y"
	TLGTABLE<090> = "Z"
	TLGTABLE<091> = "["
*
* GREEK PORTION 92
*
	TLGTABLE<092> = "W(/|"
*
* LATIN PORTION 93
*
	TLGTABLE<093> = "]"
*
* GREEK PORTION 94 - 95 		OK
*
	TLGTABLE<094> = "W)/|"
	TLGTABLE<095> = "W)\|"
*
* font-irrelevant:
*
	TLGTABLE<096> = '"3 '
*
* LATIN PORTION 97 - 123
*
	TLGTABLE<097> = "a"
	TLGTABLE<098> = "b"
	TLGTABLE<099> = "c"
	TLGTABLE<100> = "d"
	TLGTABLE<101> = "e"
	TLGTABLE<102> = "f"
	TLGTABLE<103> = "g"
	TLGTABLE<104> = "h"
	TLGTABLE<105> = "i"
	TLGTABLE<106> = "j"
	TLGTABLE<107> = "k"
	TLGTABLE<108> = "l"
	TLGTABLE<109> = "m"
	TLGTABLE<110> = "n"
	TLGTABLE<111> = "o"
	TLGTABLE<112> = "p"
	TLGTABLE<113> = "q"
	TLGTABLE<114> = "r"
	TLGTABLE<115> = "s"
	TLGTABLE<116> = "t"
	TLGTABLE<117> = "u"
	TLGTABLE<118> = "v"
	TLGTABLE<119> = "w"
	TLGTABLE<120> = "x"
	TLGTABLE<121> = "y"
	TLGTABLE<122> = "z"
	TLGTABLE<123> = "[3"
*
* GREEK PORTION 124			OK
*
	TLGTABLE<124> = "W)=|"
*
* LATIN PORTION 125
*
	TLGTABLE<125> = "]3"
*
* GREEK PORTION 126 - 255		OK
*
	TLGTABLE<126> = "W(=|"
	TLGTABLE<127> = "D"
	TLGTABLE<128> = "*A"
	TLGTABLE<129> = "*B"
	TLGTABLE<130> = "*G"
	TLGTABLE<131> = "*D"
	TLGTABLE<132> = "*E"
	TLGTABLE<133> = "*Z"
	TLGTABLE<134> = "*H"
	TLGTABLE<135> = "*Q"
	TLGTABLE<136> = "*I"
	TLGTABLE<137> = "*K"
	TLGTABLE<138> = "*L"
	TLGTABLE<139> = "*M"
	TLGTABLE<140> = "*N"
	TLGTABLE<141> = "*C"
	TLGTABLE<142> = "*O"
	TLGTABLE<143> = "*P"
	TLGTABLE<144> = "*R"
	TLGTABLE<145> = "*S"
	TLGTABLE<146> = "*T"
	TLGTABLE<147> = "*U"
	TLGTABLE<148> = "*F"
	TLGTABLE<149> = "*X"
	TLGTABLE<150> = "*Y"
	TLGTABLE<151> = "*W"
	TLGTABLE<152> = "A"
	TLGTABLE<153> = "B"
	TLGTABLE<154> = "G"
	TLGTABLE<155> = "D"
	TLGTABLE<156> = "E"
	TLGTABLE<157> = "Z"
	TLGTABLE<158> = "H"
	TLGTABLE<159> = "Q"
	TLGTABLE<160> = "I"
	TLGTABLE<161> = "K"
	TLGTABLE<162> = "L"
	TLGTABLE<163> = "M"
	TLGTABLE<164> = "N"
	TLGTABLE<165> = "C"
	TLGTABLE<166> = "O"
	TLGTABLE<167> = "P"
	TLGTABLE<168> = "R"
	TLGTABLE<169> = "S"
	TLGTABLE<170> = "S"
	TLGTABLE<171> = "T"
	TLGTABLE<172> = "U"
	TLGTABLE<173> = "F"
	TLGTABLE<174> = "X"
	TLGTABLE<175> = "Y"
	TLGTABLE<176> = "W"
	TLGTABLE<177> = ")"
	TLGTABLE<178> = "("
	TLGTABLE<179> = ")/"
	TLGTABLE<180> = "(/"
	TLGTABLE<181> = ")="
	TLGTABLE<182> = "(="
	TLGTABLE<183> = "A)"
	TLGTABLE<184> = "A("
	TLGTABLE<185> = "A/"
	TLGTABLE<186> = "A\"
	TLGTABLE<187> = "A="
	TLGTABLE<188> = "A)/"
	TLGTABLE<189> = "A)="
	TLGTABLE<190> = "A(/"
	TLGTABLE<191> = "A(="
	TLGTABLE<192> = "E)"
	TLGTABLE<193> = "E("
	TLGTABLE<194> = "E/"
	TLGTABLE<195> = "E\"
	TLGTABLE<196> = "E)/"
	TLGTABLE<197> = "E(/"
	TLGTABLE<198> = "H)"
	TLGTABLE<199> = "H("
	TLGTABLE<200> = "H/"
	TLGTABLE<201> = "H\"
	TLGTABLE<202> = "H="
	TLGTABLE<203> = "H)/"
	TLGTABLE<204> = "H)="
	TLGTABLE<205> = "H(/"
	TLGTABLE<206> = "H=("
	TLGTABLE<207> = "I)"
	TLGTABLE<208> = "I("
	TLGTABLE<209> = "I/"
	TLGTABLE<210> = "I\"
	TLGTABLE<211> = "I="
	TLGTABLE<212> = "I)/"
	TLGTABLE<213> = "I)="
	TLGTABLE<214> = "I(/"
	TLGTABLE<215> = "I(="
	TLGTABLE<216> = "O)"
	TLGTABLE<217> = "O("
	TLGTABLE<218> = "O/"
	TLGTABLE<219> = "O\"
	TLGTABLE<220> = "O)/"
	TLGTABLE<221> = "O(/"
	TLGTABLE<222> = "U)"
	TLGTABLE<223> = "U("
	TLGTABLE<224> = "U/"
	TLGTABLE<225> = "U\"
	TLGTABLE<226> = "U="
	TLGTABLE<227> = "U)/"
	TLGTABLE<228> = "U)="
	TLGTABLE<229> = "U(/"
	TLGTABLE<230> = "U(="
	TLGTABLE<231> = "W)"
	TLGTABLE<232> = "W("
	TLGTABLE<233> = "W/"
	TLGTABLE<234> = "W\"
	TLGTABLE<235> = "W="
	TLGTABLE<236> = "W)/"
	TLGTABLE<237> = "W)="
	TLGTABLE<238> = "W(/"
	TLGTABLE<239> = "W(="
	TLGTABLE<240> = "A|"
	TLGTABLE<241> = "A=|"
	TLGTABLE<242> = "H|"
	TLGTABLE<243> = "H=|"
	TLGTABLE<244> = "W|"
	TLGTABLE<245> = "W=|"
	TLGTABLE<246> = "(\"
	TLGTABLE<247> = "A)\"
	TLGTABLE<248> = "H(\"
	TLGTABLE<249> = "I(\"
	TLGTABLE<250> = "O(\"
	TLGTABLE<251> = "H(=|"
	TLGTABLE<252> = "R("
	TLGTABLE<253> = "W)\"
	TLGTABLE<254> = "W/|"
	TLGTABLE<255> = "U(\"
*****	     CHAR_PAT = POS(0) LEN(1) $ C
	MAL_ERROR_TABLE = TABLE()
	DEFINE('MAL_TLG(STRING,START_FONT)C,D,FONT')
+						:(MAL_TLG_END)
MAL_TLG
+	FONT = START_FONT
	STRING POS(0) SPAN(' ') $ C =
	MAL_TLG = MAL_TLG REPLACE(C,' ','@')
MAL_TLG_LOOP
+	STRING CHAR_PAT =			:F(RETURN)
*
*
*
	C = ASC(C)
	GE(C,126)				:S(MAL_GREEK)
	GE(C,32) LE(C,34)			:S(MAL_NORMAL)
	GE(C,39) LE(C,63)			:S(MAL_NORMAL)
	EQ(C,37)				:S(MAL_NORMAL)
	GE(C,19) LE(C,38)			:S(MAL_GREEK)
	GE(C,2) LE(C,13)			:S(MAL_GREEK)
	(
+	   EQ(C,91)
+	,
+	   EQ(C,93)
+	,
+	   EQ(C,96)
+	,
+	   EQ(C,123)
+	,
+	   EQ(C,125)
+	)					:S(MAL_NORMAL)
	(
+	   EQ(C,124)
+	,
+	   EQ(C,94)
+	,
+	   EQ(C,95)
+	,
+	   EQ(C,92)
+	)					:S(MAL_GREEK)
MAL_LATIN
+	EQ(FONT,LATIN)				:S(MAL_NORMAL)
	FONT = LATIN
	MAL_TLG = MAL_TLG '&'                   :(MAL_NORMAL)
MAL_GREEK
+	EQ(FONT,GREEK)				:S(MAL_NORMAL)
	FONT = GREEK
	MAL_TLG = MAL_TLG '$'
MAL_NORMAL
+	D = TLGTABLE<C>
	IDENT(D)				:S(MAL_ERROR)
	MAL_TLG = MAL_TLG D			:(MAL_TLG_LOOP)
MAL_ERROR
+	MAL_ERROR_TABLE<C> = MAL_ERROR_TABLE<C> + 1
	mal_tlg = mal_tlg (eq(font,GREEK) '&','')
+			  'ERRORCODE'
+			  (eq(font,GREEK) '$','')
	MAL_ERROR_FLAG = '*'                    :(MAL_TLG_LOOP)
MAL_TLG_END
